#!/bin/bash

# DONE last of month STILL not working, not number - FIX 2017.0731 / .0829
# TODO df vmdir, bkpdest > log

# NOTE cron calls this script every Sunday but will only run the actual bkp if run on LAST Sunday of month!
# REF: http://www.justskins.com/forums/cronjob-on-the-last-119680.html
# REF: https://arstechnica.com/civis/viewtopic.php?t=34360

# backup virtualbox VMs with tar.lzop AND export to .ova
# NOTE all vboxmanage commands MUST be done as $vboxuser !!

# NOTE this script may not work with Grouping -- it changes on-disk structure!
# NOTE password-protected VM(s) will ask for password interactively before exporting to .ova!!

# =LLC= © (C)opyright 2016 Boojum Consulting LLC / Dave Bechtel, All rights reserved.
## NOTICE: Only Boojum Consulting LLC personnel may use or redistribute this code,
## Unless given explicit permission by the author - see http://www.boojumconsultingsa.com
#

debugg=0

dobkp=0 # override calendar check
skipova=0 # testing; short-circuit time-intensive backup

myhn=`hostname`
bkpdate=`date +%Y%m%d`

# xxx TODO changeme or pull from $1
vboxuser=dave

outlog=~/bkpvms-virtbox-$vboxuser.log
runvmlog=/tmp/runningvms-$vboxuser.log
> $runvmlog # clearit
sortfl=/tmp/bkpvbox-$vboxuser-sortlist.txt

# hopefully FIX 2017.0712
declare -i lastofmonthchk
declare -i todaychk

# check for last Sunday
todaychk=`date +%d` # 07

# BUG xxx 2017.0829
#lastofmonthchk=`/usr/bin/cal |awk '{print $1}' |grep -E '[0-9]' |tail -n 1` # 28
# NF>0 = skip blank lines
lastofmonthchk=`/usr/bin/cal -h |awk 'NF>0' |tail -n1 |awk '{print $1}'` 
# 27

[ "$debugg" = "1" ] && echo "`date` - NOTE CURDAY:$todaychk LOM:$lastofmonthchk" #>> $outlog
  
if [ $todaychk = $lastofmonthchk ] || [ $dobkp -gt 0 ]; then
  mv -v $outlog $outlog--prev
# and continue with vm bkp
else
  echo "`date` - NOTE $todaychk -ne $lastofmonthchk - not running backup!" >> $outlog
  exit 0;
# Early abort
fi

# xxx TODO changeme
#VMdir=/home/vmtmpdir/virtbox-virtmachines
VMdir=/zseatera4/notshrcompr/virtbox-virtmachines

# xxx TODO changeme
bkpdest=/zseatera2/notshrcompr
bkpdir=$bkpdest/bkp-virtualbox-vms--$myhn

[ `echo $bkpdest |grep -c "/mnt/"` -gt 0 ] && mount $bkpdest   # mount if not ZFS!

# from failexit.mrg
function failexit () {
  echo '! Something failed! Code: '"$1 $2" # code # (and optional description)
  exit $1
}

[ -e "$bkpdest/NOTHERE" ] && failexit 99 "$bkpdest NOTHERE -- NOT MOUNTED"
# "If" checking for NOTHERE file...

chkmount=`df |grep -c $bkpdest`
[ $chkmount -gt 0 ] || failexit 99 "$bkpdest NOT MOUNTED"

########################## OK to backup

# xxx 2017.0829 boojum tweak
spinup > /dev/null

obkpdir=$bkpdir
bkpdir=$bkpdir/$bkpdate/$vboxuser
mkdir -pv $bkpdir || failexit 200 "! Unable to mkdir $bkpdir"

# copy thisexec to bkpdir, for reference
cp -v $0 $bkpdir

# Init logfile
echo "`date` - Host:$myhn -- Virtualbox backup for user:$vboxuser -- Destination: $bkpdest" > $outlog

echo "o Known VMs for $vboxuser:" >> $outlog
#grep $VMdir /home/$vboxuser/.config/VirtualBox/VirtualBox.xml |grep "MachineEntry" >> $outlog
grep "MachineEntry" /home/$vboxuser/.config/VirtualBox/VirtualBox.xml >> $outlog

# -v
chown -R $vboxuser:root $bkpdir #>> $outlog
chmod -R 750 $bkpdir #>> $outlog
#bkpdir=$bkpdir/$bkpdate

# REF: https://www.virtualbox.org/manual/ch10.html
# /home/$vboxuser/.config/VirtualBox/VirtualBox.xml 

cd $VMdir

echo "o NOTE list of running VMs for user:$vboxuser at time of backup:" >> $outlog
(su $vboxuser -c "vboxmanage list runningvms") |tee -a $outlog $runvmlog # output to TWO files

function suspresumevm () {
# Get vmstate for eachVM, no need to remove quotes - use UUID
# time vboxmanage controlvm "{697306ff-5c6a-4237-a9e4-187de684c36e}" savestate  # WORKS
##for vm in `awk '{print $1}' $runvmlog`; do # cant do this cuz we need both fields
# note - INPUT file at end
# REF: https://askubuntu.com/questions/344407/how-to-read-complete-line-in-for-loop-with-spaces
  while read vmline; do
    vm=`echo $vmline |awk '{print $1}'`
    vmUUID=`echo $vmline |awk '{print $2}'`

    vmrunning=`(su $vboxuser -c "vboxmanage showvminfo $vm --machinereadable |grep 'VMState=' |cut -f 2 -d \=")`
  [ "$debugg" = "1" ] && echo "$vm state is: $vmrunning"
  [ "$debugg" = "1" ] && echo "$vmUUID"

  # If running/paused, suspend it; otherwise Resume it
  if  [ $vmrunning = \"running\" ]; then
      echo "`date` - Suspending VM $vm..." |tee -a $outlog
      time (su $vboxuser -c "vboxmanage controlvm $vmUUID savestate");rc=$?
      [ $rc -ne 0 ] && failexit 1000 "! Failed to suspend VM $vm"
  elif [ $vmrunning = \"saved\" ];then
      echo "`date` - Resuming previously running VM $vm for user:$vboxuser..." |tee -a $outlog
      time (su $vboxuser -c "vboxmanage startvm $vmUUID --type headless") 2>>$outlog;rc=$?
      [ $rc -ne 0 ] && failexit 1001 "! Failed to resume VM $vm"
# headless is needed if running from ssh xxx 2017.0830     
	fi
  # || [[ $vmrunning == \"paused\" ]]; then
  done < $runvmlog
}

suspresumevm;

#[ "$debugg" = "1" ] && exit 0; # early testing

#<MachineEntry uuid="{a5de559a-462a-4e23-a9bb-f1ee64a7ad60}" src="/home/vmtmpdir/virtbox-virtmachines/centos6-64/centos6-64.vbox"/>                                            
#for d in `find . -name *.vbox |awk -F'/' '{print $2}'`; do du -s $d;done |sort -n
#34      testrestore-fsarchive
#100     squidserver7-kn-JEOS-201303
#136     Windows7-64-ZFS
#181     ultimate-network-deployment-appliance
#89932   centos6-64
#206116  systemrescue

# bkp vms by size, smallest first
for d in `find . -name *.vbox |awk -F'/' '{print $2}'`; do 
  du -s $d
done |sort -n > $sortfl

howmanyvms=`wc -l < $sortfl`
vmnum=1

# this is tricky, some disks/VMDKs are not in same VM dir! vmdk locations are stored in .vbox file
for vm in `awk '{print $2}' $sortfl`; do
  echo "`date` o TAR Backing up VM ($vmnum) of ($howmanyvms): $vm" |tee -a $outlog

# pv -q for non-interactive cron run xxx 2017.0507
  time tar cpf - $vm |pv -q |lzop > $bkpdir/bkp-virtbox-vm--$myhn--$vm.tar1.lzop
# this will backup Snapshots && Logs

# $ grep "HardDisk uuid" /home/vmtmpdir/virtbox-virtmachines/centos6-64/centos6-64.vbox |awk -F'location=' '{print $2}' |awk '{print $1}'
#"/home/vmtmpdir/virtbox-virtmachines/64bit/centos6-64/Centos6-64-scsi-0-0.vmdk"
#"/home/vmtmpdir/virtbox-virtmachines/64bit/centos6-64/Centos6-64-scsi0-1-zfs.vmdk"

# Better to back it up as an .ova all-in-1: REF: http://askubuntu.com/questions/588426/how-to-export-and-import-virtualbox-vm-images
# PROBLEM: root does not have list of $vboxuser's virtbox VMs! need to do this as $vboxuserid
#  thisvm=`vboxmanage list vms |grep $vm |awk '{print $1}'`
  thisvm=`su $vboxuser -c "vboxmanage list vms" |grep $vm |awk '{print $1}'`

#   j=${i//_/-}    # inline sed, replace ALL underline with dash
#  thisvm=${thisvm//"/} # inline sed, delete ALL quotes  # not work

  tvmnq=`echo $thisvm |tr -d '"'` # delete ALL double-tick quotes 

  if [ -e $bkpdir/$tvmnq.ova ] || [ "$skipova" = "1" ]; then
    echo "NOTE: .OVA Backup of .$tvmnq. already exists -- skipping" |tee -a $outlog
  else
    echo "`date` o Exporting .$tvmnq. to .OVA file..." |tee -a $outlog

    (su $vboxuser -c "vboxmanage export --ovf20 --manifest $tvmnq -o $bkpdir/$tvmnq.ova") 2>>$outlog;rc=$?
    [ $rc -gt 0 ] && echo "! ERROR - RC: $rc" |tee -a $outlog
  fi
  
  let vmnum=$vmnum+1
done # processing VM list

# enumerate VM info (Quits at Description) - NOTE overwrites existing sortfl 
# REF: http://unix.stackexchange.com/questions/11305/grep-show-all-the-file-up-to-the-match
# Get list of VMs and remove quotes
echo "`date` o Enumerating VM details..." |tee -a $outlog
    
su $vboxuser -c "vboxmanage list vms" |awk '{print $1}' |tr -d '"' |sort >$sortfl

# for v in `awk '{print $1}' /tmp/vboxvms`; do vboxmanage showvminfo $v |sed '/Description/q';done|less
for v in `awk '{print $1}' $sortfl`; do 
  su $vboxuser -c "vboxmanage showvminfo $v" |sed '/Description/q' > "$bkpdir/vminfo--$v.txt"
done

cd $bkpdir
flist &

# xxxxx 2017.0919 TODO fixme
#echo "`date` - Resuming previously running VMs..." |tee -a $outlog
echo "`date` - Note - NOT Resuming previously running VMs..." |tee -a $outlog
#suspresumevm;

echo "`date` - $myhn - All virtualbox backups done" |tee -a $outlog
cp -v $outlog $bkpdir

exit;

Thanks to:
Kapitein Vorkbaard for some ideas/features

$ vboxmanage list vms |awk '{print $1}' |tr -d '"' |sort >/tmp/vboxvms
centos6-64
centos7
fryserver-ubuntu1604-64test
p2700-p2v-ubuntu1004-64
p2v-host-ubuntu1404
squidserver7-kn-JEOS-201303
systemrescue
testrestore-fsarchive
ubuntu-ctn-edition-1204
ultimate-network-deployment-appliance
Win7--64vboxbeta
Windows7-64-ZFS

$ cal
      May 2017        
Su Mo Tu We Th Fr Sa  
    1  2  3  4  5  6  
 7  8  9 10 11 12 13  
14 15 16 17 18 19 20  
21 22 23 24 25 26 27  
28 29 30 31           
