#!/bin/bash

# TODO df vmdir, bkpdest > log

# export/backup vmware VMs to .ova
# NOTE all vmrun commands MUST be done as $vmwareuser !!

# adapted from bkpvms-virtbox-boojum

debugg=0

dobkp=1 # override calendar check
skipova=0 # testing; short-circuit time-intensive backup
preverify=0 # test .vmx files for errors (pre-process

myhn=`hostname`
bkpdate=`date +%Y%m%d`

# xxx TODO changeme or pull from $1
vmwareuser=dave

outlog=~/bkpvms-vmware-$vmwareuser.log
runvmlog=/tmp/runningvms-$vmwareuser.log
> $runvmlog # clearit
sortfl=/tmp/bkpvmware-$vmwareuser-sortlist.txt

declare -i lastofmonthchk
declare -i todaychk

# check for last Sunday
todaychk=`date +%d` # 07

# BUG xxx 2017.0829
#lastofmonthchk=`/usr/bin/cal |awk '{print $1}' |grep -E '[0-9]' |tail -n 1` # 28
# NF>0 = skip blank lines
lastofmonthchk=`/usr/bin/cal -h |awk 'NF>0' |tail -n1 |awk '{print $1}'` 
# 27

[ "$debugg" = "1" ] && echo "`date` - NOTE CURDAY:$todaychk LOM:$lastofmonthchk" #>> $outlog
  
if [ $todaychk = $lastofmonthchk ] || [ $dobkp -gt 0 ]; then
  mv -v $outlog $outlog--prev
# and continue with vm bkp
else
  echo "`date` - NOTE $todaychk -ne $lastofmonthchk - not running backup!" >> $outlog
  exit 0;
# Early abort
fi

# changeme - xxx these are currently not used
#VMdir=/mnt/bigvaitera/vmware-virtmachines
# TODO also can pull this from /home/X/.vmware/preferences:
#prefvmx.defaultVMPath = "/home/vmtmpdir/vmware-virtmachines"                                                                           
#VMdir2="/home/vmtmpdir/vmware-virtmachines"                                                                           

# xxx TODO changeme
# Network bkp to ZFS compr
bkpdest=/mnt/frysea2dv
bkpdir=$bkpdest/shrcompr/bkp-vmware-vms--$myhn

[ `echo $bkpdest |grep -c "/mnt/"` -gt 0 ] && mount $bkpdest   # mount if not ZFS!

# from failexit.mrg
function failexit () {
  echo '! Something failed! Code: '"$1 $2" # code # (and optional description)
  exit $1
}

[ -e "$bkpdest/NOTHERE" ] && failexit 99 "$bkpdest NOTHERE -- NOT MOUNTED"
# "If" checking for NOTHERE file...

chkmount=`df |grep -c $bkpdest`
[ $chkmount -gt 0 ] || failexit 99 "$bkpdest NOT MOUNTED"

########################## OK to backup

# xxx 2017.0829 boojum tweak
spinup > /dev/null

obkpdir=$bkpdir
bkpdir=$bkpdir/$bkpdate/$vmwareuser
mkdir -pv $bkpdir || failexit 200 "! Unable to mkdir $bkpdir"

# copy thisexec to bkpdir, for reference
cp -v $0 $bkpdir

# Init logfile
echo "`date` - Host:$myhn -- Vmware backup for user:$vmwareuser -- Destination: $bkpdest" > $outlog

echo "o Known VMs for $vmwareuser:" >> $outlog
#grep $VMdir /home/$vmwareuser/.config/VirtualBox/VirtualBox.xml |grep "MachineEntry" >> $outlog
grep "\.vmx" /home/$vmwareuser/.vmware/inventory.vmls |egrep "\.config|\.id" >> $outlog
# valid for vmware workstation 11.1.4 as of Jan 2018

# -v
chown -R $vmwareuser:root $bkpdir 2>> $outlog
chmod -R 750 $bkpdir 2>> $outlog
#bkpdir=$bkpdir/$bkpdate

#cd $VMdir

echo "o NOTE list of running VMs for user:$vmwareuser at time of backup:" >> $outlog
(su $vmwareuser -c "vmrun list")|grep -v "Total" |tee -a $outlog $runvmlog # output to TWO files

function suspresumevm () {
##for vm in `awk '{print $1}' $runvmlog`; do # cant do this cuz we need both fields
# note - INPUT file at end
# REF: https://askubuntu.com/questions/344407/how-to-read-complete-line-in-for-loop-with-spaces
  while read vmline; do
    vm=`echo $vmline |awk '{print $1}'`

  # If running/paused, suspend it
#  if  [ $vmrunning = \"running\" ]; then
      echo "`date` - Suspending VM $vm..." |tee -a $outlog
      time (su $vmwareuser -c "vmrun suspend $vm");rc=$?
      [ $rc -ne 0 ] && failexit 1000 "! Failed to suspend VM $vm"
#  elif [ $vmrunning = \"saved\" ];then
#      echo "`date` - Resuming previously running VM $vm for user:$vmwareuser..." |tee -a $outlog
#      time (su $vmwareuser -c "vmwaremanage startvm $vmUUID --type headless") 2>>$outlog;rc=$?
#      [ $rc -ne 0 ] && failexit 1001 "! Failed to resume VM $vm"
# headless is needed if running from ssh xxx 2017.0830     
#  fi
  # || [[ $vmrunning == \"paused\" ]]; then
  done < $runvmlog
}

suspresumevm;

#[ "$debugg" = "1" ] && exit 0; # early testing

# bkp vms by size, smallest first
# DONE find some way of handling dup names in different dirs - recreate path
#47303096        /mnt/bigvaitera/vmware-virtmachines/64bit/Win7--64
#65092632        /mnt/bigvaitera/vmware-virtmachines/BETA/Win7--64

# since we have 2 VM dirs, can put both in find with FQPath
#for d in `find $VMdir $VMdir2 -name *.vmx`; do # |awk -F'/' '{print $2}'`; do 
#/mnt/bigvaitera/vmware-virtmachines/p2v-host-ubuntu1404/p2v-host-ubuntu1404.vmx
#/home/vmtmpdir/vmware-virtmachines/win7-32--restore-from-court2130/win7-32--restore-from-court2130.vmx

# FIX to handle spaces
OLDIFS=$IFS
NEWIFS='
'
IFS=$NEWIFS

for d in `locate *.vmx |grep -v vmx--only`; do # |awk -F'/' '{print $2}'`; do 
  pathonly=${d%/*}  # strip evy after last "/"
  du -s "$pathonly"
done |sort -n > $sortfl

howmanyvms=`wc -l < $sortfl`
vmnum=0

# some disks/VMDKs are not in same VM dir! vmdk locations are stored in .vmware file
for vm in `awk '{print $2}' $sortfl`; do
  let vmnum=$vmnum+1
  echo "`date` o Backing up VM ($vmnum) of ($howmanyvms): $vm" |tee -a $outlog

# pv -q for non-interactive cron run xxx 2017.0507
#  time tar cpf - $vm |pv -q |lzop > $bkpdir/bkp-virtbox-vm--$myhn--$vm.tar1.lzop
# this will backup Snapshots && Logs

# Better to back it up as an .ova all-in-1: REF: http://askubuntu.com/questions/588426/how-to-export-and-import-virtualbox-vm-images
# PROBLEM: root does not have list of $vmwareuser's VMs! need to do this as $vmwareuserid

# This is the VM DIR
# ex. /mnt/bigvaitera/vmware-virtmachines/p2700-p2v-ubuntu1004
  cd "$vm"
  pwd |tee -a $outlog

# TODO make sure no dup .vmx files here??
#  thisvm=`basename $vm` # strip out beginning path, p2v-host-ubuntu1404.vmx
  thisvm=`ls *.vmx |head -n 1`

  tvmnq=`echo "${thisvm// /-}"` # trans spaces to dashes REF: https://unix.stackexchange.com/questions/290242/converting-spaces-into-dashes

# bash if not
if [ ! "$thisvm" = "$tvmnq" ]; then
  echo "NOTE - corrected spaces in .vmx filename for $vm/$thisvm - you need to re-open it in the GUI" |tee -a $outlog
  cp -apv "$thisvm" "$tvmnq" # MAKE IT SANE OTF, NO SPACES!!
  mv -v "$thisvm" "$thisvm--old"
  thisvm=`ls *.vmx |head -n 1`
fi

  origpath=`echo "$vm" |cut -b 2-`
# strip leading slash so we can recreate dir structure 
  
  if [ -e $bkpdir/$origpath/$tvmnq.ova ] || [ "$skipova" = "1" ]; then
    echo "SKIP NOTE: .OVA Backup of .$tvmnq. already exists" |tee -a $outlog
    continue # skip
  elif [ `grep -c "encryption\.keySafe" "$thisvm"` -gt 0 ]; then
# TODO cp/rsync disks manually here?  
    echo "TODO NOTE: Encrypted VM .$origpath/$tvmnq. -- backup this VM manually!" |tee -a $outlog
  elif [ $preverify -gt 0 ]; then
    ovftool --noDisks ${thisvm} /dev/null 2>>$outlog;rc=$?
#    [ $rc -gt 0 ] && failexit 999 "! PREVERIFY ERROR - RC: $rc for $origpath/$thisvm" 
# NOTE not good to failexit here, ovftool will display "null" already exists :-\
    [ $rc -gt 0 ] && echo 999 " ! PREVERIFY ERROR - RC: $rc for $origpath/$thisvm" |tee -a $outlog
  else
    echo "`date` o Exporting .$tvmnq. to .OVA file..." |tee -a $outlog
    mkdir -pv "$bkpdir/$origpath"

# NOTE backing up to already-compressed dest is MUCH faster!
#    (set -x; su $vmwareuser -c "time ovftool -dm=thin --compress=1 ${thisvm} $bkpdir/$origpath/$tvmnq.ova") 2>>$outlog;rc=$?
# TODO --lax ? -dm=monolithicSparse?
# NOTE - su does not pass IFS, spaces are futile! FIX - rename .vmx files with spaces if they error
    (set -x; su $vmwareuser -c "time ovftool -dm=thin ${thisvm} $bkpdir/$origpath/$tvmnq.ova") 2>>$outlog;rc=$?
    [ $rc -gt 0 ] && echo "! ERROR - RC: $rc for $origpath/$thisvm" |tee -a $outlog
  fi
  
#  let vmnum=$vmnum+1
# moved to top due to skipping
done # processing VM list

ls -alh $bkpdir/*

# xxxxx 2017.0919 TODO fixme
#echo "`date` - Resuming previously running VMs..." |tee -a $outlog
echo "`date` - Note - NOT Resuming previously running VMs..." |tee -a $outlog
#suspresumevm;

echo "`date` - $myhn - All vmware backups done for this user" |tee -a $outlog
cp -v $outlog $bkpdir

IFS=$OLDIFS

egrep 'TODO|ERROR' $outlog
exit;

2018.0102 adapted to vmware from fryserver bkpvms-virtbox
DONE enable 1st pass: $ ovftool --noDisks isoserver-linux.vmx /dev/null
DONE re-print anything that needs manual intervention from log @end
