#!/bin/bash

# TODO copy info from boojum-setup-encrypted-zfs-share.sh
# TODO boojum staff, update getdrives-byid before running this!
debugg=0
zp=zencrypt4

# pass parm to use disk 3, etc
usepd=$1
[ "$usepd" = "" ] && usepd=2
# TODO more sanity checks, is this even a number?

# This also includes WWN
dpathi=/dev/disk/by-id  
dpathp=/dev/disk/by-path
# If doing SCSI drives, use this

source /root/bin/getdrive-byids

source /root/bin/failexit.mrg

declare -a zdisk    # regular indexed array
zdisk[1]=$DpooldiskA
zdisk[2]=$DpooldiskB
zdisk[3]=$DpooldiskC
#zdisk[4]=$DpooldiskD

source /root/bin/boojum/wait4resilver.mrg

function gmestatus () {
  date
  zpool status |awk 'NF>0'
  zfs list
  df |head -n 1
  df |grep $zp
}

function initdisk () {
(set -x
# NOTE dpath must be supplied manually since we can do mixed SATA+SCSI!
  echo "FYI initdisk $1"
  zpool labelclear $1 || failexit 1000 "! Failed to zpool labelclear $1"
  parted -s $1 mklabel gpt || failexit 1234 "! Failed to apply GPT label to disk $1"
)
}
            
gmestatus

insanity2="${zdisk[$usepd]}"
[ "$insanity2" = "" ] && failexit 199 "! Invalid disk number specified - not known!"

# check zpool status |grep -c disk, if already allocated cant go!
# we can get around this if needed with: # zpool status -P
#/dev/disk/by-path/pci-0000:00:14.0-scsi-0:0:0:0-part1  ONLINE       0     0     0

# remove what we dont need: # ${string##substring}
tmpzdisk=${zdisk[$usepd]##*/}  # strip out all leading */ - NOTE global "*" is needed to get them all!
declare -i insanity=`zpool status |grep -c $tmpzdisk`  # Count; declare Integer (number)
[ $debugg -gt 0 ] && echo "TMPZDISK:.$tmpzdisk."
[ $debugg -gt 0 ] && echo "INSANITY:.$insanity."

[ $insanity -gt 0 ] && failexit 299 "! ${zdisk[$usepd]} Is already allocated to the pool - cannot proceed!"


echo "o Enter BOOJUM ADMIN PASSWORD to Expand ZFS POOL $zp USING DISK ${zdisk[$usepd]}"
echo " OR press ^C: "
read

# TODO check for GPT partn?
# init if this was a hot add
initdisk ${zdisk[$usepd]}

time zpool add -o ashift=12 $zp \
   ${zdisk[$usepd]}  

waitforresilver

gmestatus

echo "o Complete! -- `date`"

exit;

2017.0415 TESTED OK with 3 disks (2 scsi + 1 SATA hot-add) == OK
