#!/bin/bash

# Intent - start with (1) 4GB disk and set it up as a samba share, have another 4GB disk for expansion
# Adapted from zfsdemo-zredpool-probox-1-drive-to-4-raid10.sh

# NOTE THIS SCRIPT INITS BOTH DISKS!!!

# HOWTO - edit, search this file for TODO and replace things where necessary before running!
# NOTE this script will auto-GPT-label new disks!!!

# (C)opyright 2017 Boojum Consulting
# GOAL - create an expandable, encrypted ZFS samba shared pool and add samba user+password if needed

debugg=1

logfile=~/boojum-setup-encrypted-zfs.log
> $logfile # clearit

# TODO xxxxx change this to the zfs pool you are working on!
zp=zencrypt4

# This also includes WWN
#dpath=/dev/disk/by-id

dpath=/dev/disk/by-path
# If doing SCSI drives, use this

# failexit.mrg
function failexit () {
  echo '! Something failed! Code: '"$1 $2" # code # (and optional description)
  exit $1
}

# Echo something to current console AND log
# Can also handle piped input ( cmd |logecho )
# Warning: Has trouble echoing '*' even when quoted.
function logecho () {
  args=$@

  if [ -z "$args" ]; then
    args='tmp'

    while [ 1 ]; do
      read -e -t2 args

      if [ -n "$args" ]; then
         echo $args |tee -a $logfile;
      else
        break;
      fi
    done

  else
    echo $args |tee -a $logfile;
  fi
} # END FUNC


# xxxxx TODO change disks here!
declare -a pooldisks 	# regular indexed array
pooldisks[1]="pci-0000:00:14.0-scsi-0:0:0:0" #-> ../../sdb
pooldisks[2]="pci-0000:00:14.0-scsi-0:0:1:0" #-> ../../sdc
#pooldisks[3]=usb-WDC_WD10_EFRX-68FYTN0_152D00539000-0:2
#pooldisks[4]=usb-WDC_WD10_EFRX-68FYTN0_152D00539000-0:3
#pooldisks[5]=

function waitforresilver () {
	printf `date +%H:%M:%S`' ...waiting for resilver to complete...'
	waitresilver=1
	while [ $waitresilver -gt 0 ];do 
	  waitresilver=`zpool status -v $zp |grep -c resilvering`
	  sleep 5
	done 
	echo 'Syncing to be sure'; time sync;
	date |logecho
}

function initdisk () {
(set -x
	logecho "FYI initdisk $1"
  zpool labelclear $dpath/$1 || failexit 1000 "! Failed to zpool labelclear $1"
  parted -s $dpath/$1 mklabel gpt || failexit 1234 "! Failed to apply GPT label to disk $1"
)
}

function logzpstatus () {
  zpool status -v $zp >> $logfile
	zpool status -v $zp 

	zfs list $zp >> $logfile 
	zpool list $zp >> $logfile 
}

function nomorepool () {
 echo "!!! I AM ABOUT TO OBLITERATE ZFS POOL $1 -- ENTER BOOJUM ADMIN PASSWORD OR Press ^C to abort!"
 read

 zfs umount -f $1 2>> $logfile

# zpool export $1 2>> $logfile

 zpool status $1
 zpool destroy -f $1 2>> $logfile
 zpool status -L -P -x
}

################################# TEH MAIN THING

# DESTROY!!
nomorepool $zp

df -h
zpool status $zp
echo "POOL $zp SHOULD BE GONE -PK TO PROCEED, or ^C"
read

# getting rid of sync for each dd should speed things up
echo "o Preparing disks..."
# xxxxx TODO for number of disks
for i in {1..2};do
  printf $i...

# NECESSARY if re-using disks that were previously in a pool!!
  initdisk ${pooldisks[$i]}
done
    

############ create 1-disk NORAID
(set -x
 time zpool create -f -o ashift=12 -O atime=off -O compression=lz4 $zp \
   ${pooldisks[1]} )

# Evidently we can only do 1 setting at a time... turn trace=on for this 1 command in subshell
(set -x
  zpool set autoexpand=on $zp) || failexit 99 "! Autoexpand failed with $zp"
(set -x
  zpool set autoreplace=on $zp) || failexit 992 "! Autoreplace failed with $zp"

#df -h /$zp
#logzpstatus

echo 'o Should now have a 1-disk, non-redundant pool with room to expand to a 2nd disk:'
zpool status $zp |awk 'NF>0'
#; df -h /$zp

# Make some datasets
# TODO make func.mrg
# zfs create -o compression=lz4 -o atime=off -o sharesmb=on zredpool2/0DISPOSABLE-VEEAM-P3300-BKP ;chown dave /zredpool2/0DISPOSABLE-VEEAM-P3300-BKP

# TODO change if needed
myuser=user; carg=""

# check if samba user exists
tmpchk=`pdbedit -L -v |grep -c "$myuser"`
if [ "$tmpchk" -gt 0 ]; then
  logecho "o FYI: Samba user $myuser already exists"
else
(set -x
 smbpasswd -a "$myuser" )
fi

myds=sambasharecompr
#[ "$debugg" -gt 1 ] && 
carg="-v"
(set -x
  zfs create -o atime=off -o sharesmb=on $zp/$myds ; chown $carg $myuser /$zp/$myds ) # chown -v
#  zfs create -o compression=lz4 -o atime=off -o sharesmb=on $zp/$myds ; chown $carg $myuser /$zp/$myds ) # chown -v
  
# mount samba share locally
#mount /mnt/demoshare
    
logecho "o Taking demo snapshot of $zp and all datasets..." 
# we dont need this, pool is brand new
#zfs destroy -R -v $zp@demosnapshot 2>&1 >>$logfile
zfs snapshot -r $zp@demosnapshot
zfs-list-snaps--boojum.sh #|logecho
zfs-list-snaps--boojum.sh >> $logfile
 
df
   
echo 'o Complete!'

# To expand pool later:
# time zpool add -o ashift=12 $zp \
#   ${pooldisks[2]}

exit;

