#!/bin/bash


# =LLC= © (C)opyright 2016 Boojum Consulting LLC / Dave Bechtel, All rights reserved.
## NOTICE: Only Boojum Consulting LLC personnel may use or redistribute this code,
## Unless given explicit permission by the author - see http://www.boojumconsultingsa.com
#
# NOTE this script assumes you have already setup /etc/squid3 , squid.conf , and /etc/fstab

# failexit.mrg
function failexit () {
  echo '! Something failed! Code: '"$1 $2" # code # (and optional description)
  exit $1
}

logfile=/root/boojum-squid-install.log
> $logfile

# if dir
[ -d /etc/squid3 ] || failexit 101 "! Make sure /etc/squid3 dir exists!"

# if config file
[ -e /etc/squid3/squid.conf ] || failexit 102 "! Make sure /etc/squid3/squid.conf exists and is configured correctly for thisbox!"

chkfstab=`grep -c /mnt/squid /etc/fstab`
[ $chkfstab -gt 0 ] || failexit 103 "! Make sure /mnt/squid is configured in /etc/fstab!"

mount /mnt/squid

ourdev=`df |grep mnt/squid |awk '{print $1}'` # /dev/sdf7
tune2fs -m1 $ourdev || failexit 200 "! tune2fs /mnt/squid failed! Make sure /mnt/squid is ext4, and tune2fs is installed"

mkdir -pv /mnt/squid/cache
chown proxy:proxy /mnt/squid/cache

mkdir -pv /var/log/squid3
chown proxy:proxy /var/log/squid3

mkdir -pv /usr/share/squid3/errors/CUSTOM
(cd /etc/squid3; tar cpf - CUSTOM |(cd /usr/share/squid3/errors; tar xpf -))
ls -l /usr/share/squid3/errors/* |head -n 5 |tee -a $logfile

function setproxy () {
 export http_proxy=http://$1:3128
 export https_proxy=http://$1:3128
 export ftp_proxy=http://$1:3128
# set|grep proxy=
}
    
/sbin/ifconfig |grep addr |egrep -v 'inet6|Base|Link' |gawk '{ printf "%s", $2 " | " }' # all on 1 line
    
# Network test
echo '';echo ''
pingok=1
ping -c 4 google.com || pingok=0
if [ $pingok -eq 1 ]; then
  echo "OK - PING GOOGLE, proceeding"
else
  failexit 404 "! Ping google FAILED! Cannot proceed - check network"
fi

# noproxy
unset ftp_proxy;unset http_proxy;unset https_proxy;
  
time apt-get update
apt-get install -y squid3 |tee -a $logfile     
# NOTE requires "N" or Enter input to keep existing squid.conf file!


setproxy localhost
set |grep proxy= |tee -a $logfile
echo 'Testing squid on localhost:3128 ...' |tee -a $logfile
time apt-get update >> $logfile

ls -alh /var/log/squid3 |tee -a $logfile

#ps ax|grep squid
renice -5 `pidof squid3`
ps axo pid,user,ni,psr,pcpu,comm|grep squid |tee -a $logfile
# 1292 proxy     -5   0  0.0 squid3

tail /var/log/squid3/cache.log
echo '-======-'
tail -n 5 /var/log/squid3/access.log

exit;

Fixed:
2016/05/31 06:32:42| ERROR: Error Directory /usr/share/squid3/errors/CUSTOM: (2) No such file or directory
FATAL: Error Directory /usr/share/squid3/errors/CUSTOM: (2) No such file or directory
Squid Cache (Version 3.3.8): Terminated abnormally.
