#!/bin/bash

# =LLC= © (C)opyright 2016 Boojum Consulting LLC / Dave Bechtel, All rights reserved.
## NOTICE: Only Boojum Consulting LLC personnel may use or redistribute this code,
## Unless given explicit permission by the author - see http://www.boojumconsultingsa.com
#
# to be run every month 17th and 27th ~9:35pm to not conflict with snapshots

log=/root/smartlog-boojum.log
mv -v -f $log $log--old

if [ "$1" = "stage2" ]; then
  myd=`date`
  echo "=========================================" |tee -a $log
  echo "o BEGIN Boojum STAGE2 SMART report: $myd" |tee -a $log
  
  for i in /dev/sd?;do
    drvonly=`echo $i |awk -F/ '{ print $3 }'` # sda
    bid=`ls -l /dev/disk/by-id |grep $drvonly |grep -v part`

    echo $i |tee -a $log
    echo "$bid" |tee -a $log
    /sbin/fdisk -l $i |tee -a $log
    /usr/sbin/smartctl -a $i |tee -a $log
  done
  echo "=========================================" |tee -a $log
  echo "o END Boojum STAGE2 SMART report: $myd" |tee -a $log

  boojum-smart-shortreport.sh &
    
  exit 0; # skip test
fi

# (to syslog)
logger "`date` - Boojum FYI -- SMARTCTL testing of all drives are in progress - see $log"

echo "=========================================" |tee -a $log  
echo "o BEGIN Boojum STAGE1 SMART testing: $myd" |tee -a $log 

# SMART testing
for i in /dev/sd?;do
  drvonly=`echo $i |awk -F/ '{ print $3 }'` # sda
  bid=`ls -l /dev/disk/by-id |grep $drvonly |grep -v part`

  echo $i |tee -a $log
  echo "$bid" |tee -a $log
  /sbin/fdisk -l $i |tee -a $log
  /usr/sbin/smartctl -t long $i |tee -a $log
done

echo "=========================================" |tee -a $log
  