#!/bin/bash

# NOTE PWD needs to be ZFS
which fio || apt -y install fio

logfile=~/fio-zfs-test.log
mv -v $logfile $logfile-old

clearcache; sleep 2
echo "`date` - Starting fio tests"

# REF: https://martin.heiland.io/2018/02/23/zfs-tuning/
(echo "`date` - Random read"
fio --filename=test --sync=1 --rw=randread --bs=4k --numjobs=1 --iodepth=4 --group_reporting --name=test --filesize=10G --runtime=300 --output-format=terse \
&& rm -v test) > $logfile

clearcache; sleep 2

(echo "`date` - Random write"
fio --filename=test --sync=1 --rw=randwrite --bs=4k --numjobs=1 --iodepth=4 --group_reporting --name=test --filesize=10G --runtime=300 --output-format=terse \
&& rm -v test) >> $logfile

clearcache; sleep 2

(echo "`date` - Sequential read"
fio --filename=test --sync=1 --rw=read --bs=4k --numjobs=1 --iodepth=4 --group_reporting --name=test --filesize=10G --runtime=300 --output-format=terse \
&& rm -v test) >> $logfile

clearcache; sleep 2

(echo "`date` - Sequential write"
fio --filename=test --sync=1 --rw=write --bs=4k --numjobs=1 --iodepth=4 --group_reporting --name=test --filesize=10G --runtime=300 --output-format=terse \
&& rm -v test) >> $logfile

clearcache
echo "`date` - $0 DONE - LOG= $logfile - dont forget to run zpool trim"
