#!/bin/bash

# BKP2FSARCHIVE 1ST!!
# Add std pkgs to new install, after running -purgedebs 1st to make space

# 2017.1029 for antix 17

logfile=~/freshinstall.log

function addpkgs {
# apt-get install -y --force-yes $*
 apt-get install -y --allow-unauthenticated $*
} 2>>$logfile

# REF: https://www.virtualbox.org/wiki/Linux_Downloads
wget -q https://www.virtualbox.org/download/oracle_vbox_2016.asc -O- | sudo apt-key add -
wget -q https://www.virtualbox.org/download/oracle_vbox.asc -O- | sudo apt-key add -

apt-get update

# essential
addpkgs joe mc lynx screen lzop fsarchiver netcat-traditional

# 2006.0828 for vmware:
addpkgs linux-headers-`uname -r` build-essential apt-file 
#libc6-i386 ia32-libs

# Removed from deflt knoppix
addpkgs lftp  gftp  ethstatus bwm-ng
# ncftp 

# AUDIO STUFF
addpkgs sox
# 2017.1029 no install pkg  deadbeef

addpkgs rdesktop  ssh 
addpkgs thunar  xfce4-terminal xterm rxvt
# xffm4 no pkg 2017.1029

addpkgs mingetty 
#log2mail 

addpkgs synaptic aptitude 
#debian-goodies 
addpkgs nano  reportbug  

addpkgs smartmontools geeqie

# SCSI stuff
addpkgs lsscsi scsitools sdparm  sg3-utils
#/unstable

# TOYS
addpkgs cmatrix xaos
#xearth  xsnow  cmatrix

# No longer provided by cron
#addpkgs checksecurity

addpkgs w3m udftools 

addpkgs squid3 nmap iptraf


# xxx pkgs installed from localinfo
addpkgs  sshfs jfsutils sysstat pv  ethtool  gparted  iotop  android-tools-adb  dos2unix

#DONE + installed pkgs  zfs, samba,
#+ installed pkg zfs - https://github.com/zfsonlinux/zfs/wiki/Debian

addpkgs xine-ui vlc icedax  p7zip unrar smbclient  x11vnc xfce4-terminal  # TODO - codecs? - to play dvds
#TODO?  + installed pkg /usr/share/doc/libdvdread4/install-css.sh

addpkgs libreoffice

addpkgs xvt  evince  httrack  chromium  xz-utils  exfat-utils 

#TODO install sep pkg + installed pkg deadbeef # for playing ogg/mp3 music

addpkgs cups hplip hplip-gui # for printing

#TODO: installed pkg nomachine nx + SKIP migrated /usr/NC/etc/node.cfg

addpkgs firefox-esr thunderbird

addpkgs pavucontrol pulseaudio # for HDMI sound # apt-get install pavucontrol

addpkgs lxde ttf-dejavu-core 

addpkgs autossh 


#+ installed pkg # apt-get install virtualbox 
addpkgs virtualbox-5.2


# Moved to end due to prompt/weirdness/needs config

# ZFS on linux
#2017.0223 FIX + installed pkg zfsutils-linux # was missing 'zpool' cmd
# REF: https://github.com/zfsonlinux/zfs/wiki/Debian / https://packages.debian.org/source/stretch/zfs-linux
addpkgs zfs-dkms zfsutils-linux samba smbclient


addpkgs localepurge vsftpd
#addpkgs discover  vsftpd  sawfish  localepurge  rcconf scsiadd icewm
addpkgs mutt

addpkgs sarg 
# for squid reports - REF: https://www.tecmint.com/sarg-squid-analysis-report-generator-and-internet-bandwidth-monitoring-tool/


apt-file update
echo "`date` - DONE"

exit;

# NVIDIA driver
#addpkgs linux-amd64-generic
#addpkgs nvidia-glx

# AUDIO STUFF
addpkgs sox deadbeef
##addpkgs abcde
##addpkgs ecawave
##addpkgs mpgtx
##addpkgs grip
##addpkgs mp3burn
##addpkgs mp3c
# (mp3 creator)
##addpkgs id3
##addpkgs flac
##addpkgs groovycd

# No longer avail; use JRE
##addpkgs jdk1.1

# not exist anymore
##addpkgs pine
## Remember to remove mutt!

##addpkgs cdplayer

#timezoneconf 
## autoinstall
# (duplicate system installation pkgs)

##addpkgs bastille
##addpkgs dmsetup
##addpkgs easyfw
# (firewall config GUI)

##addpkgs jablicator
# (Allow others to dup your setup)

##addpkgs linuxconf
# - consider webmin...

#addpkgs webmin webmin-lvm webmin-samba webmin-smart-status webmin-squid webmin-status webmin-filemanager
#lvm2 

##addpkgs psad
# (attack detection)
##svgatextmode

##addpkgs xarchon
##addpkgs xonix

#VERY BAD - removes sysvinit!!
##addpkgs usbmgr

#addpkgs zgv  xwpe gnome-terminal multi-gnome-terminal rxvt
# powershell
#  sysv-rc  sysv-rc-conf

# 2006.0828
#addpkgs xmms

#2006.0407
#addpkgs gaim bittorrent cadaver gqview libjpeg-progs

##addpkgs ntop

#2003.0325 - Sopwith game!! :)
##addpkgs sopwith
##addpkgs gnome-gataxx
# Too many gnome dependencies; also, replaced by gnome-games. 2006.0407

##addpkgs kpoker
