#!/bin/bash

# EDIT ME 1ST!!

source ~/bin/failexit.mrg

zp=zsg25lap1
zfsuser=dave 		# FOR SAMBA SHARES

DBI=/dev/disk/by-id
DBP=/dev/disk/by-path

disk1=ata-ST1000LM024_HN-M101MBB_S2RQJ9CC903375 
disk1L=$DBI/$disk1
#disk2=$DBI/
#disk2L=$DBI/$disk2
#disk3=$DBI/
#disk3L=$DBI/$disk3
#disk4=$DBI/
#disk4L=$DBI/$disk4
#disk5=$DBI/
#disk5L=$DBI/$disk5
#disk6=$DBI/
#disk6L=$DBI/$disk6

# note zpool status -L  # resolves to short names, e.g. sde
outfyl=/tmp/`basename $0`-checktmp.txt
zpool status -v > $outfyl

#[ `zpool status -v |grep -c $disk1` -gt 0 ] && failexit 101 "! $disk1 is in use by another zpool!"
[ `grep -c $disk1 $outfyl` -gt 0 ] && failexit 101 "! $disk1 is in use by another zpool!"
#[ `grep -c $disk2 $outfyl` -gt 0 ] && failexit 102 "! $disk2 is in use by another zpool!"
#[ `grep -c $disk3 $outfyl` -gt 0 ] && failexit 103 "! $disk3 is in use by another zpool!"
#[ `grep -c $disk4 $outfyl` -gt 0 ] && failexit 104 "! $disk4 is in use by another zpool!"
#[ `grep -c $disk5 $outfyl` -gt 0 ] && failexit 105 "! $disk5 is in use by another zpool!"
#[ `grep -c $disk6 $outfyl` -gt 0 ] && failexit 106 "! $disk6 is in use by another zpool!"


function make1disk () {
	zpool create -o ashift=12 -o autoexpand=on -O atime=off -O compression=lz4 $zp \
	  $disk1L
}	  

function make2disk () {
	zpool create -o ashift=12 -o autoexpand=on -O atime=off -O compression=lz4 $zp \
	  mirror $disk1L $disk2L || failexit 99 "! Unable to create zpool $zp"
}

function make4disk () {
	zpool create -o ashift=12 -o autoexpand=on -O atime=off -O compression=lz4 $zp \
		mirror $disk1L $disk2L \
		mirror $disk3L $disk4L || failexit 99 "! Unable to create zpool $zp"
}

function make6disk () {
	zpool create -o ashift=12 -o autoexpand=on -O atime=off -O compression=lz4 $zp \
	  mirror $disk1L $disk2L \
	  mirror $disk3L $disk4L \
	  mirror $disk5L $disk6L || failexit 99 "! Unable to create zpool $zp"
}


# xxx What kind to create?
make1disk;
zpool status |awk 'NF>0'


function ownlist () {
	chown -v $zfsuser /$zp/$mydir
	ls -la /$zp/$mydir
}	  

function makezdscompshare () {
	zfs create -o atime=off -o compression=lz4 -o sharesmb=on $zp/$mydir
	ownlist
}

function makezdsNOTcompOKshare () {
	zfs create -o atime=off -o compression=off -o sharesmb=on $zp/$mydir
	ownlist
}

function makezdsOKcompNOTshare () {
	zfs create -o atime=off -o compression=lz4 -o sharesmb=off $zp/$mydir
	ownlist
}

function makezdsNOTcompNOTshare () {
	zfs create -o atime=off -o compression=off -o sharesmb=off $zp/$mydir
	ownlist
}

mydir=shared; makezdscompshare $mydir

mydir=notshrcompr; makezdsOKcompNOTshare $mydir

mydir=notshrnotcompr; makezdsNOTcompNOTshare $mydir


# Custom
mydir=BURNME-notshrcompr; makezdsOKcompNOTshare $mydir


df |head -n 1
df |grep $zp

exit;

DONE check 'zpool list' and see if drive(s) are already in use!!
