#!/bin/bash

# kill boojum DOM snapshots for range of days (1-31)
# TODO BOOJUM STAFF - EDIT FIRST!!

# REF: https://sysadminman.net/blog/2008/remove-all-zfs-snapshots-50

# TODO default=today
# TODO more sanity

debugg=0
# NOTE debugg set will NOT actually kill snaps!

#myds=zbkpteratmp/compr
myds=bigvaiterazfsNB/home/vmtmpdir
drange="14 21" # INCLUSIVE!!

[ "$1" = "" ] || crit="$1"

logfile=/root/zfs-killsnaps.log
[ $debugg -gt 0 ] && logfile=/root/TEST-zfs-killsnaps.log

[ $debugg -gt 0 ] && > $logfile # clearit for testing

#for snapshot in `zfs list -H -t snapshot |grep hourly | cut -f 1`
function dokill () {
  crit=$1
  for snapshot in `zfs list -H -t snapshot |grep $myds |grep DOM$crit |cut -f 1`
  do
    echo "`date` - Killing $snapshot" |tee -a $logfile
[ $debugg = 0 ] && time zfs destroy $snapshot
  done
}

echo "! YOU ARE ABOUT TO DESTROY MULTIPLE ZFS SNAPSHOTS FOR .$myds. DOM $drange"
echo "ENTER BOOJUM ADMIN PASSWORD or ^C"
read

# zero-pad; NOTE quoting drange results in error here
for kme in $(seq -w $drange); do
  dokill $kme
done

ls -l $logfile

exit;

$ seq 20 23
20
21
22
23

$ seq -w $drange
04
05
06
07
08
09
10
11

bigvaiterazfsNB/home/vmtmpdir@boojumDOM16          7.10G      -   350G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM25             8K      -   358G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM27             8K      -   358G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM28             8K      -   358G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM29            88K      -   358G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM30          1.83G      -   358G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM31            96K      -   358G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM01           260M      -   358G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM03           441M      -   359G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM04            96K      -   359G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM05            96K      -   359G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM06           104K      -   366G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM07             8K      -   367G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM08             8K      -   367G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM09             8K      -   367G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM10          1.92G      -   367G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM11          3.38G      -   373G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM12             8K      -   373G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM13             8K      -   373G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM14          1.76G      -   373G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM15             8K      -   390G  -
bigvaiterazfsNB/home/vmtmpdir@Mon                      0      -   390G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM17              0      -   390G  -
bigvaiterazfsNB/home/vmtmpdir@Tue                      0      -   391G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM18              0      -   391G  -
bigvaiterazfsNB/home/vmtmpdir@Wed                      0      -   391G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM19              0      -   391G  -
bigvaiterazfsNB/home/vmtmpdir@Thu                      0      -   391G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM20              0      -   391G  -
bigvaiterazfsNB/home/vmtmpdir@Fri                      0      -   391G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM21              0      -   391G  -
bigvaiterazfsNB/home/vmtmpdir@Sat                      0      -   391G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM22              0      -   391G  -
bigvaiterazfsNB/home/vmtmpdir@Sun                      0      -   389G  -
bigvaiterazfsNB/home/vmtmpdir@boojumDOM23              0      -   389G  -

Sun Apr 23 15:50:18 CDT 2017 - Killing bigvaiterazfsNB/home/vmtmpdir@boojumDOM14
Sun Apr 23 15:50:18 CDT 2017 - Killing bigvaiterazfsNB/home/vmtmpdir@boojumDOM15
Sun Apr 23 15:50:18 CDT 2017 - Killing bigvaiterazfsNB/home/vmtmpdir@boojumDOM16
Sun Apr 23 15:50:18 CDT 2017 - Killing bigvaiterazfsNB/home/vmtmpdir@boojumDOM17
Sun Apr 23 15:50:19 CDT 2017 - Killing bigvaiterazfsNB/home/vmtmpdir@boojumDOM18
Sun Apr 23 15:50:19 CDT 2017 - Killing bigvaiterazfsNB/home/vmtmpdir@boojumDOM19
Sun Apr 23 15:50:19 CDT 2017 - Killing bigvaiterazfsNB/home/vmtmpdir@boojumDOM20
Sun Apr 23 15:50:19 CDT 2017 - Killing bigvaiterazfsNB/home/vmtmpdir@boojumDOM21
