#!/bin/bash

# zfs: re-balance a dataset into 1M recordsize - send/recv to same system

doitok=0  # 1=no dry run

# TODO EDITME!
szp=zredpool2
sds=home/vmtmpdir/vmware-virtmachines

dzp=zmixed3
dds=vmware-virtmachines

source ~/bin/failexit.mrg

#  zfs-newds.sh 10 zmixed3 vmware-virtmachines
(set -x
 zfs create -o \
  atime=off -o compression=lz4 -o sharesmb=off -o recordsize=1024k \
    $dzp/$dds || failexit 99 "! Failed to create destination ZFS $dzp/$dds"
) 
    
#  zfs snapshot -r zredpool2/home/vmtmpdir/vmware-virtmachines@DISPOSABLEBKP
(set -x
 zfs destroy -R -v $szp/$sds@DISPOSABLEBKP
 zfs snapshot -r $szp/$sds@DISPOSABLEBKP
)

# Dry run
#  time zfs send -Dpv zredpool2/home/vmtmpdir/vmware-virtmachines@DISPOSABLEBKP |zfs recv -Fevn zmixed3/vmware-virtmachines

if [ $doitok -gt 0 ]; then
  sropts="-Fev"
else
  sropts="-Fevn"
fi

# don't need pv, V provides 
time zfs send -Dpv $szp/$sds@DISPOSABLEBKP \
  |zfs recv -Fev $dzp/$dds \
   && zfs destroy -R -v $szp/$sds@DISPOSABLEBKP

zfs get recordsize,compression,sharesmb $dzp/$dds
df -h -T $szp/$sds $dzp/$dds

echo "`date` - $0 done"
exit;

send from @ to zredpool2/home/vmtmpdir/vmware-virtmachines@DISPOSABLEBKP estimated size is 268G
total estimated size is 268G
TIME        SENT   SNAPSHOT
receiving full stream of zredpool2/home/vmtmpdir/vmware-virtmachines@DISPOSABLEBKP into
 zmixed3/vmware-virtmachines/vmware-virtmachines@DISPOSABLEBKP
           