#!/bin/bash

# create ZFS pool that should be cross-boot compatible and import OK

# REF: https://www.reddit.com/r/zfs/comments/b092at/cant_import_pool_from_zol_to_bsd/
# REF: https://zgrep.org/zfs.html  # zfs by-OS compat. chart
# REF ' man zpool-features ' - large_blocks needed for recordsize=1024k

#DBI=/var/run/disk/by-id
#DBP=/var/run/disk/by-path
#DBS=/var/run/disk/by-serial

DBI=/dev/disk/by-id
DBP=/dev/disk/by-path

# EDITME!
zp=zredtera1C
diskk=$DBI/scsi-SExt_Hard_Disk-part2 # Linux - use dev/disk/by-id

# wtf, we get error cannot resolve path?? evidently zpool create doesnt like "$diskk" - do it manually
#diskk="$DBS/EFRX-68FYTN0-WD-WCC4J4KD08T6 $DBS/EFRX-68FYTN0-WD-WCC4J2HEAE4A" # Linux - use dev/disk/by-id
#diskk="/dev/disk7 /dev/disk3"

zpool create -f -d \
 -o feature@async_destroy=enabled \
 -o feature@bookmarks=enabled \
 -o feature@embedded_data=enabled \
 -o feature@empty_bpobj=enabled \
 -o feature@enabled_txg=enabled \
 -o feature@spacemap_histogram=enabled \
 -o feature@filesystem_limits=enabled \
 -o feature@lz4_compress=enabled \
 -o feature@large_blocks=enabled \
 -o ashift=12 -o autoexpand=off \
 -O atime=off -O compression=lz4 $zp $diskk # works fine for single disk
# -O atime=off -O compression=lz4 $zp mirror $DBS/EFRX-68FYTN0-WD-WCC4J4KD08T6 $DBS/EFRX-68FYTN0-WD-WCC4J2HEAE4A
 
 zpool status -v
 